import 'package:mocktail_image_network/mocktail_image_network.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:protonimage/protonimage.dart';
import 'package:flutter/material.dart';

void main() {
  testWidgets('Protonimage Test', (WidgetTester tester) async {
    // Network Image PATH:URL
    final imageUrl =
        'https://cdn.dribbble.com/users/730703/screenshots/17515984/media/4dd92322fb915b00e6a0f0f3b1d4bf6c.jpg';

    //Arrange - Pump MyApp() widget to tester
    await mockNetworkImages(
      () async => tester.pumpWidget(
        MaterialApp(
          debugShowCheckedModeBanner: false,
          title: 'Proton Image Example',
          home: Scaffold(
            appBar: AppBar(
              title: Text('Proton Image Example'),
            ),
            body: SafeArea(
              child: SingleChildScrollView(
                child: Center(
                  child: Column(
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: [
                      // Quick Use
                      ProtonImage(
                        path: imageUrl,
                        height: 200,
                        radius: 20,
                      ),
                      SizedBox(height: 20),

                      //Advance Use
                      ProtonImage(
                        path: imageUrl,
                        height: 200,
                        radius: 20,
                        aspectRatio: 16 / 9,
                        baseColor: Colors.blue.withOpacity(0.3),
                        highlightColor: Colors.blue.withOpacity(0.6),
                      ),
                      SizedBox(height: 20),

                      //Image Overlay
                      ProtonImage(
                        path: imageUrl,
                        height: 200,
                        radius: 20,
                        aspectRatio: 16 / 9,
                        baseColor: Colors.blue.withOpacity(0.3),
                        highlightColor: Colors.blue.withOpacity(0.6),
                        overlayGradient: LinearGradient(
                          begin: Alignment.bottomRight,
                          stops: const [0.1, 0.8],
                          colors: [
                            Colors.black45.withOpacity(.1),
                            Colors.black45.withOpacity(.0),
                          ],
                        ),
                      ),
                      SizedBox(height: 20),

                      //Transparent
                      ProtonImage(
                        path: imageUrl,
                        height: 200,
                        radius: 20,
                        backgroundColor: Colors.transparent,
                      ),
                      SizedBox(height: 20),
                    ],
                  ),
                ),
              ),
            ),
          ),
        ),
      ),
    );

    //Act - Find ProtonImage by type
    expect(find.byType(ProtonImage), findsNWidgets(4));
  });
}
